#include "common.as"
#include "camera.as"

CCamera cam;

CGuiElement @mouse;
const CEntity @player;

void onShowGui()
{
	CreateMouse();
	
	@player = null;
}

void onFrame()
{
	if( player is null )
		@player = game.FindEntityByName('player');

	cam.Update(player);

	// Check for mouse click
	if( input.DidActionStart(actionUse) )
	{
		// Determine position of the mouse in the game world
		vector2 wp = game.ScreenToWorld(mouse.position);
		
		game.SendMessage(player, msgSetWayPoint, CWayPoint(wp.x, wp.y));
	}
}

void CreateMouse()
{
	@mouse = @gui.CreateElement(vector2(0,0), vector2(32,32));
	mouse.center = vector2(16,24);
	gui.SetMouseElement(mouse);
	mouse.srcImageIndex = gui.LoadImage("arrow.png");
	mouse.zPosition = -1000; // Make sure the cursor is in front of all other elements
}