class CDoor : IEntityController
{
	CDoor(CEntity @ent)
	{
		@entity = ent;
		closedPos = ent.position;
		entity.awake = false;
	}

	void onThink()
	{
		// If we wake up, it is because we the door reached an end position
		if( abs(entity.position.y - closedPos.y) > 0.001 )
		{
			// Let's close the door after 2 seconds
			entity.SetTimer(2, 0);
			entity.awake = false;
		}
	}

	void onTimer(int id)
	{
		// Close the door
		Close();
	}
  
	void onCollide(const CEntity @object, const vector2 &in position, const vector2 &in normal, float approachSpeed)
	{
		if( object !is null && object.type == "player" )
		{
			// Determine if the player has picked up the key already
			int64 key;
			game.GetProperty('key_'+entity.name, key);
			if( key != 0 )
				Open();
			
			// TODO: Play some sound or do something to tell player the door is locked
		}
	}

	void Open()
	{
		entity.MoveTo(closedPos+vector2(0,5), 5);
	}

	void Close()
	{
		entity.MoveTo(closedPos, 5);
	}

	CEntity @entity;
	vector2  closedPos;
}