#include "common.as"

// TODO: Should be possible to prevent modifying these properties from other scripts
uint level = 0;
array<string> levels = {'test.map', 'test2.map'};
uint livesBeforeStart;

// These are properties that can be accessed from other scripts
// TODO: Maybe I can use metadata to show the properties that are shared
uint lives = 5;

void onStartGame()
{
	gui.LoadScript('gui.as');

	// Start the level
	BackupPlayerState();
	game.SetGravity(vector2(0, -40));
	game.LoadLevel(levels[level]);
}

void onEndLevel(int code)
{
	if( code == endLevelSucceed )
	{
		// Commit changes to player by backing up the data
		BackupPlayerState();

		// Was this the last level?
		if( ++level == levels.length() )
		{
			// Show end animation
			game.ShowMenu(3);
			return;
		}

		// Show between levels menu
		game.ShowMenu(2);
	}
	else if( code == endLevelFail )
	{
		// Show menu where player get to quit or restart level
		game.ShowMenu(1);
	}
}

void onRestartLevel()
{
	RestorePlayerState();
	game.SetGravity(vector2(0, -40));
	game.LoadLevel(levels[level]);
}

void BackupPlayerState()
{
	livesBeforeStart = lives;
}

void RestorePlayerState()
{
	lives = livesBeforeStart;
}